| API Docs for SAX and DOM |

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XMLAttr Class Reference

This class defines the information about an attribute that will come out of the scanner during parsing. More...

`#include <XMLAttr.hpp>`

Collaboration diagram for XMLAttr:

[legend]
List of all members.

## Public Methods

Constructors
| XMLAttr ()
| The default constructor just setsup an empty attribute to be filled in the later. More...
| XMLAttr (const unsigned int uriId,const XMLCh *const attrName,const XMLCh *const attrPrefix,const XMLCh *const attrValue,const XMLAttDef::AttTypes type=XMLAttDef::CData,const bool specified=true)
| This is the primary constructor which takes all of the information required to construct a complete attribute object. More...
Destructor
| ~XMLAttr ()
Getter methods
QName* | getAttName ()const
| This methode returns the attribute name in a QName format.
const XMLCh* | getName ()const
| This method gets a const pointer tot he name of the attribute. More...
const XMLCh* | getPrefix ()const
| This method will get a const pointer to the prefix string of this attribute. More...
const XMLCh* | getQName ()const
| This method will get the QName of this attribute, which will be the prefix if any, then a colon, then the base name. More...
bool | getSpecified ()const
| This method will get the specified flag, which indicates whether the attribute was explicitly specified or just faulted in.
XMLAttDef::AttTypes | getType ()const
| This method will get the type of the attribute. More...
const XMLCh* | getValue ()const
| This method will get the value of the attribute. More...
unsigned int | getURIId ()const
| This method will get the id of the URI that this attribute's prefix mapped to. More...
Setter methods
void | set (const unsigned int uriId,const XMLCh *const attrName,const XMLCh *const attrPrefix,const XMLCh *const attrValue,const XMLAttDef::AttTypes type=XMLAttDef::CData)
| This method is called to set up a default constructed object after the fact, or to reuse a previously used object. More...
void | setName (const unsigned int uriId,const XMLCh *const attrName,const XMLCh *const attrPrefix)
| This method will update just the name related fields of the attribute object. More...
void | setSpecified (const bool newValue)
| This method will update the specified state of the object. More...
void | setType (const XMLAttDef::AttTypes newType)
| This method will update the attribute type of the object. More...
void | setValue (const XMLCh *const newValue)
| This method will update the value field of the attribute. More...
void | setURIId (const unsigned int uriId)
| This method will set the URI id field of this attribute. More...

## Detailed Description

This class defines the information about an attribute that will come out of the scanner during parsing.

This information does not depend upon the type of validator because it is not tied to any scheme/DTD type info. Its just the raw XML 1.0 information that will be reported about an attribute in the startElement() callback method of the XMLDocumentHandler class. Hence it is not intended to be extended or derived from. Its designed to be used as is.

The 'specified' field of this class indicates whether the attribute was actually present or whether it was faulted in because it had a fixed or default value.

The code receiving this information can ask its validator for more info about the attribute, i.e. get its declaration from the DTD/Schema info.

Because of the heavy use (and reuse) of instances of this class, and the number of string members it has, this class takes pains to not reallocate string members unless it has to. It keeps up with how long each buffer is and only reallocates if the new value won't fit.

## Constructor & Destructor Documentation

XMLAttr::XMLAttr ( | )

| The default constructor just setsup an empty attribute to be filled in the later. Though the initial state is a reasonable one, it is not documented because it should not be depended on.

XMLAttr::XMLAttr ( | const unsigned int uriId,
| const XMLCh *const attrName,
| const XMLCh *const attrPrefix,
| const XMLCh *const attrValue,
| const XMLAttDef::AttTypes type = XMLAttDef::CData,
| const bool specified = true )

This is the primary constructor which takes all of the information required to construct a complete attribute object.

Parameters:

  uriId | The id into the validator's URI pool of the URI that the prefix mapped to. Only used if namespaces are enabled/supported.
  attrName | The base name of the attribute, i.e. the part after any prefix.
  attrPrefix | The prefix, if any, of this attribute's name. If this is empty, then uriID is meaningless as well.
  attrValue | The value string of the attribute, which should be fully normalized by XML rules!
  type | The type of the attribute. This will indicate the type of normalization done and constrains the value content. Make sure that the value set meets the constraints!
  specified | Indicates whether the attribute was explicitly specified or not. If not, then it was faulted in from a FIXED or DEFAULT value.

XMLAttr::~XMLAttr ( | )

## Member Function Documentation

QName * XMLAttr::getAttName ( | ) const

| This methode returns the attribute name in a QName format.

const XMLCh * XMLAttr::getName ( | ) const

| This method gets a const pointer tot he name of the attribute. The form of this name is defined by the validator in use.

const XMLCh * XMLAttr::getPrefix ( | ) const

| This method will get a const pointer to the prefix string of this attribute. Since prefixes are optional, it may be zero.

const XMLCh * XMLAttr::getQName ( | ) const

| This method will get the QName of this attribute, which will be the prefix if any, then a colon, then the base name. If there was no prefix, its the same as the getName() method.

bool XMLAttr::getSpecified ( | ) const

| This method will get the specified flag, which indicates whether the attribute was explicitly specified or just faulted in.

XMLAttDef::AttTypes XMLAttr::getType ( | ) const

| This method will get the type of the attribute. The available types are defined by the XML specification.

unsigned int XMLAttr::getURIId ( | ) const

| This method will get the id of the URI that this attribute's prefix mapped to. If namespaces are not on, then its value is meaningless.

const XMLCh * XMLAttr::getValue ( | ) const

| This method will get the value of the attribute. The value can be be an empty string, but never null if the object is correctly set up.

void XMLAttr::set ( | const unsigned int uriId,
| const XMLCh *const attrName,
| const XMLCh *const attrPrefix,
| const XMLCh *const attrValue,
| const XMLAttDef::AttTypes type = XMLAttDef::CData )

This method is called to set up a default constructed object after the fact, or to reuse a previously used object.

Parameters:

  uriId | The id into the validator's URI pool of the URI that the prefix mapped to. Only used if namespaces are enabled/supported.
  attrName | The base name of the attribute, i.e. the part after any prefix.
  attrPrefix | The prefix, if any, of this attribute's name. If this is empty, then uriID is meaningless as well.
  attrValue | The value string of the attribute, which should be fully normalized by XML rules according to the attribute type.
  type | The type of the attribute. This will indicate the type of normalization done and constrains the value content. Make sure that the value set meets the constraints!

void XMLAttr::setName ( | const unsigned int uriId,
| const XMLCh *const attrName,
| const XMLCh *const attrPrefix )

This method will update just the name related fields of the attribute object.

The other fields are left as is.

Parameters:

  uriId | The id into the validator's URI pool of the URI that the prefix mapped to. Only used if namespaces are enabled/supported.
  attrName | The base name of the attribute, i.e. the part after any prefix.
  attrPrefix | The prefix, if any, of this attribute's name. If this is empty, then uriID is meaningless as well.

void XMLAttr::setSpecified ( | const bool newValue )

This method will update the specified state of the object.

Parameters:

  newValue | Indicates whether the attribute was explicitly specified or not. If not, then it was faulted in from a FIXED or DEFAULT value.

void XMLAttr::setType ( | const XMLAttDef::AttTypes newValue )

This method will update the attribute type of the object.

Parameters:

  newType | The type of the attribute. This will indicate the type of normalization done and constrains the value content. Make sure that the value set meets the constraints!

void XMLAttr::setURIId ( | const unsigned int uriId )

This method will set the URI id field of this attribute.

This is generally only ever called internally by the parser itself during the parsing process.

Parameters:

  uriId | The uriId of the attribute.

void XMLAttr::setValue ( | const XMLCh *const newValue )

This method will update the value field of the attribute.

Parameters:

  newValue | The value string of the attribute, which should be fully normalized by XML rules according to the attribute type.

The documentation for this class was generated from the following file:

- XMLAttr.hpp

Copyright © 2000 The Apache Software Foundation. All Rights Reserved.